#!/usr/bin/python

import sys

from experiment import Experiment

from settings import *
from src.drawers import *


experiments = []

# Experiment 1
class AnaliseGlobal (Experiment):
    id = '1_AnaliseGlobal'

experiments.append(AnaliseGlobal)

# Experiment 2
class FrequenciaMinimaDeUmAno (Experiment):
    id = '2_FrequenciaMinimaDeUmAno'
    gap_min_days = 7
    gap_max_days = 365
    group_interval = INF

experiments.append(FrequenciaMinimaDeUmAno)

# Experiment 3
class LimiteDeDoacoesEmUmAno (Experiment):
    id = '3_LimiteDeDoacoesEmUmAno'
    gap_min_days = 7
    group_interval = 365
    highest_donation_class = 12

experiments.append(LimiteDeDoacoesEmUmAno)

# Experiment 4
class LimiteDeDoacoesEmDoisAnos (Experiment):
    id = '4_LimiteDeDoacoesEmDoisAnos'
    gap_min_days = 7
    group_interval = 365 * 2
    highest_donation_class = 12

experiments.append(LimiteDeDoacoesEmDoisAnos)

# Experiment 5
class LimiteMinimoTresMeses (Experiment):
    id = '5_LimiteMinimoTresMeses'
    gap_min_days = 90
    group_interval = 365
    highest_donation_class = 5

experiments.append(LimiteMinimoTresMeses)

# Run experiments
for arg in sys.argv[1:]:
    experiments[int(arg)-1]().run()
