# -- coding: utf-8 --
""" Script usado para extrair séries temporais de hemoglobina e hematócritos dos
doadores de sangue.
"""

import sys
import os
import datetime

from src import *


def extractor(output_file):

    db = SingletonDB()

    try:
        f = open(output_file, 'r')
        first_line = f.readline()
        meta = eval(first_line)
        if not meta == db.meta:
            print "meta", id(meta), meta
            print "db.meta", id(db.meta), db.meta
            s = "Settings are different than target file. Fix it or delete '%s', bye!" % output_file
            sys.exit(s)

        num_donors = meta['num_donors']
        num_extracted = len(f.readlines()) # reads remainder lines
        if not num_extracted <= num_donors:
            s = "Extracted more than requested! Bye!"
            sys.exit(s)

        # File and settings match, try to continue where it had stopped
        if num_extracted == num_donors: # Job done!
            return # nothing to do
        else: # Continue processing
            f = open(output_file, 'a')
    except IOError:
        # File does not exists, initialize stuff
        f = open(output_file, 'w')
        # first line printing
        f.write(str(db.meta) + "\n")
        num_extracted = 0
        num_donors = db.meta['num_donors']

    # Extracts remaining time series and write do output file
    for i in xrange(num_extracted, num_donors):
        donor_id = db.donor_ids[i]

        d = Donor(donor_id)
        d.extract_time_series()

        # write to the file
        f.write(str(d))

        # progress logging
        progress_logger('Extraction', i, num_donors)
        i += 1

    f.close()
